from PySteppables import *
import CompuCell
import CompuCellSetup
import sys


#Exercise 1
#in XML file or in configure Simulation file make sure you have CenterOfMass plugin and SurfaceTracker plugin
# note, any surface  plugins will implicitely include Surface tracker
class InfoPrinterSteppable(SteppablePy):
   def __init__(self,_simulator,_frequency=10):
      SteppablePy.__init__(self,_frequency)
      self.simulator=_simulator
      self.inventory=self.simulator.getPotts().getCellInventory()
      self.cellList=CellList(self.inventory)

   def start(self):
      print "This function is called once before simulation"

   def step(self,mcs):
      print "This function is called every 10 MCS"
      lastCell=None
      for cell in self.cellList:
         print "CELL ID=",cell.id, " CELL TYPE=",cell.type," volume=",cell.volume," surface=",cell.surface," xCM=",cell.xCM/float(cell.volume),\
         " yCM=",cell.yCM/float(cell.volume)," zCM=",cell.zCM/float(cell.volume)
         lastCell=cell
      print "Cell attributes: \n",dir(lastCell)


#Exercise 2
#make sure you have  SurfaceTracker plugin
# note, any surface  plugins will implicitely include Surface tracker
#in CompuCell3D for 2D simulation surface area of the cell is cell.volume, and perimater of the cell is cell.surface
class ExtraAttributeCellsortExercise2(SteppablePy):
   def __init__(self,_simulator,_frequency=10):
      SteppablePy.__init__(self,_frequency)
      self.simulator=_simulator
      self.inventory=self.simulator.getPotts().getCellInventory()
      self.cellList=CellList(self.inventory)

   def step(self,mcs):
      import math
      for cell in self.cellList:
         list_attrib=CompuCell.getPyAttrib(cell)
         print "length=",len(list_attrib)
         list_attrib[0:3]=[cell.volume/float(cell.surface**2),sqrt(cell.volume/math.pi),cell.surface/(2*math.pi)]
         print "CELL ID=",cell.id," V/S**2=",list_attrib[0],"   r(area)=", list_attrib[1]," r(perimeter)=",list_attrib[2]


#Exercise 3
#make sure you have  SurfaceTracker plugin
# note, any surface  plugins will implicitely include Surface tracker
#in CompuCell3D for 2D simulation surface area of the cell is cell.volume, and perimater of the cell is cell.surface
class ExtraAttributeCellsortExercise3(SteppablePy):
   def __init__(self,_simulator,_frequency=10):
      SteppablePy.__init__(self,_frequency)
      self.simulator=_simulator
      self.inventory=self.simulator.getPotts().getCellInventory()
      self.cellList=CellList(self.inventory)

   def step(self,mcs):
      import math
      last_dict_attrib=None
      for cell in self.cellList:
         dict_attrib=CompuCell.getPyAttrib(cell)

         dict_attrib["vol_sur_ratio"]=cell.volume/float(cell.surface**2)
         dict_attrib["r_area"]=sqrt(cell.volume/math.pi)
         dict_attrib["r_perimeter"]=cell.surface/(2*math.pi)
         print "CELL ID=",cell.id," V/S**2=",dict_attrib["vol_sur_ratio"],"   r(area)=", dict_attrib["r_area"],\
         " r(perimeter)=",dict_attrib["r_perimeter"]
         last_dict_attrib=dict_attrib
      #prining entire dictionary without konwing key values - note , last_dict_attrib.keys() is a list of keys in the last_dict_attrib dictionary
      for key in last_dict_attrib.keys():
         print "key=",key," value=",last_dict_attrib[key]


#Exercise 4 

class TypeSwitcherSteppableExercise4(SteppablePy):
   def __init__(self,_simulator,_frequency=100):
      SteppablePy.__init__(self,_frequency)
      self.simulator=_simulator
      self.inventory=self.simulator.getPotts().getCellInventory()
      self.cellList=CellList(self.inventory)

   def step(self,_mcs):
      import random
      for cell in self.cellList:
         print "MCS=",_mcs
         print "not _mcs%100=",not _mcs%100
         print "_mcs%200=",_mcs%200
         print "_mcs%300=",_mcs%300


         if not _mcs%100 and _mcs%200 and _mcs%300:
            cell.type=1
         if  (not _mcs%200) and _mcs%300:
            cell.type=2
         if not _mcs%300:
            cell.type=random.randint(1,2)  # change 2 to 3 to also include type id 3
            #If you initialize cell with cell type 3 without declaring it in the CellType plugin you will get run time error in CompuCell3D




#Exercise 5
# make sure you include the followqing line in t he main script
#pyAttributeAdder,dictAdder=CompuCellSetup.attachListToCells(sim)

class NeighborTrackerPrinterSteppableExercise5(SteppablePy):
   def __init__(self,_simulator,_frequency=100):
      SteppablePy.__init__(self,_frequency)
      self.simulator=_simulator
      self.nTrackerPlugin=CompuCell.getNeighborTrackerPlugin()

      self.inventory=self.simulator.getPotts().getCellInventory()
      self.cellList=CellList(self.inventory)
   def start(self):pass

   def step(self,mcs):
      self.cellList=CellList(self.inventory)
      for cell in self.cellList:
         neighbor_list_attrib=CompuCell.getPyAttrib(cell)

         # you need to clear the list becaue at each MCS list of cell neighbors might vary\
         # cells get and loose neighbors while the simulation is running

         neighbor_list_attrib=[]

         cellNeighborList=CellNeighborListAuto(self.nTrackerPlugin,cell)
         print "*********NEIGHBORS OF CELL WITH ID ",cell.id," *****************"
         for neighborSurfaceData in cellNeighborList:
            if neighborSurfaceData.neighborAddress:
               neighbor_list_attrib.append(neighborSurfaceData.neighborAddress.id)
            else:
               neighbor_list_attrib.append(0)
         print "Neighbors of cell ",cell.id," are ",neighbor_list_attrib



#make sure you have CenterOfMass plugin in your XML filke or in configureSimulation function
class Exercise6b(SteppablePy):
   def __init__(self,_simulator,_frequency=100):
      SteppablePy.__init__(self,_frequency)
      self.simulator=_simulator

      self.inventory=self.simulator.getPotts().getCellInventory()
      self.cellList=CellList(self.inventory)
   def setCuttofCoordinate(self,_yCutoff):
       self.yCutoff=_yCutoff

   def start(self):
      for cell in self.cellList:
         if self.yCutoff>cell.yCM/float(cell.volume):
            cell.type=1
         else:
            cell.type=2


#make sure you have CenterOfMAss plugin in your XML filke or in configureSimulation function
class Exercise6c(SteppablePy):
   def __init__(self,_simulator,_frequency=100):
      SteppablePy.__init__(self,_frequency)
      self.simulator=_simulator
      self.inventory=self.simulator.getPotts().getCellInventory()
      self.cellList=CellList(self.inventory)
      self.fieldDim=self.simulator.getPotts().getCellFieldG().getDim()
      self.midPoint=CompuCell.Point3D(int(self.fieldDim.x/2.0),int(self.fieldDim.y/2.0),0)
   def setCuttofCoordinate(self,_yCutoff):
       self.yCutoff=_yCutoff

   def start(self):

      for cell in self.cellList:
         if (self.midPoint.x>cell.xCM/float(cell.volume) and self.midPoint.y>cell.yCM/float(cell.volume))\
         or (self.midPoint.x<cell.xCM/float(cell.volume) and self.midPoint.y<cell.yCM/float(cell.volume)):
            cell.type=1
         else:
            cell.type=2


class Exercise7a(SteppablePy):
   def __init__(self,_simulator,_frequency=100):
      SteppablePy.__init__(self,_frequency)
      self.simulator=_simulator
      self.inventory=self.simulator.getPotts().getCellInventory()
      self.cellList=CellList(self.inventory)

   def step(self,_mcs):

      try:
         fileName="Output_"+str(_mcs)+".dat"
         fileHandle=open(fileName,"w")
      except IOError:
         print "Could not open file ", fileName," for writing. Check if you have necessary permissions"


      for cell in self.cellList:
         fileHandle.write("%d\t%d\t%f\t%f\t%f\n"%(cell.id,cell.type,cell.xCM/float(cell.volume),cell.yCM/float(cell.volume),cell.zCM/float(cell.volume)))

      fileHandle.close()

class Exercise7b(SteppablePy):
   def __init__(self,_simulator,_frequency=100):
      SteppablePy.__init__(self,_frequency)
      self.simulator=_simulator
      self.inventory=self.simulator.getPotts().getCellInventory()
      self.cellList=CellList(self.inventory)

   def setCellId(self,_id):
      self.cellIdLocal=_id;
      #here we will clean the file by opeining it in a write mode and closeing it without actually writing anything to it
      fileName="TrackCell_"+str(self.cellIdLocal)+".dat"
      fileHandle=open(fileName,"w") #here we will append
      fileHandle.close()

   def step(self,_mcs):

      try:
         fileName="TrackCell_"+str(self.cellIdLocal)+".dat"
         fileHandle=open(fileName,"a") #here we are opening a file in the append mode append
      except IOError:
         print "Could not open file ", fileName," for writing. Check if you have necessary permissions"


      for cell in self.cellList:
         if cell.id==self.cellIdLocal:
            fileHandle.write("%d\t%f\t%f\t%f\n"%\
            (_mcs,cell.xCM/float(cell.volume),cell.yCM/float(cell.volume),cell.zCM/float(cell.volume)))

      fileHandle.close()


class Exercise7c(SteppablePy):
   def __init__(self,_simulator,_frequency=100):
      SteppablePy.__init__(self,_frequency)
      self.simulator=_simulator
      self.inventory=self.simulator.getPotts().getCellInventory()
      self.cellList=CellList(self.inventory)

   def setCellId(self,_id):
      self.cellIdLocal=_id;

   def setScalarField(self,_field):
      self.scalarField=_field

   def step(self,_mcs):

      for cell in self.cellList:
         if cell.id==self.cellIdLocal:
            fillScalarValue(self.scalarField,int(round(cell.xCM/float(cell.volume))),int(round(cell.yCM/float(cell.volume))),0,_mcs)


#Exercise8 is implemented fully in Python - there is no XML because for steering to take place you need to configure
# simulation in Python. Use cellsort-2D-player-new-syntax-steering-Exercise8 to run the simulation
class ContactSteeringExercise8(SteppablePy):
   def __init__(self,_simulator,_frequency=1):
      SteppablePy.__init__(self,_frequency)
      self.simulator=_simulator
      self.contactParseData=CompuCellSetup.getModuleParseData("Contact")
      self.sortingFlag=True
      self.checkerboardFlag=False
   def switchToSorting(self):
      enTupple=self.contactParseData.getContactEnergyTupple("Condensing","NonCondensing")
      if enTupple:
         enTupple.energy=11
      enTupple=self.contactParseData.getContactEnergyTupple("Condensing","Condensing")
      if enTupple:
         enTupple.energy=2
      enTupple=self.contactParseData.getContactEnergyTupple("NonCondensing","NonCondensing")
      if enTupple:
         enTupple.energy=16


   def switchToCheckerboard(self):
      enTupple=self.contactParseData.getContactEnergyTupple("Condensing","NonCondensing")
      if enTupple:
         enTupple.energy=2
      enTupple=self.contactParseData.getContactEnergyTupple("Condensing","Condensing")
      if enTupple:
         enTupple.energy=16
      enTupple=self.contactParseData.getContactEnergyTupple("NonCondensing","NonCondensing")
      if enTupple:
         enTupple.energy=16

   def setTSorted(self,_tSorted):
      self.tSorted=_tSorted
      self.counter=self.tSorted
   def setTCheckerboard(self,_tCheckerboard):
      self.tCheckerboard=_tCheckerboard

   def step(self, _mcs):
      self.counter-=self.frequency
      if not self.counter and self.sortingFlag:
         self.switchToCheckerboard()
         self.checkerboardFlag=True
         self.sortingFlag=False
         self.counter=self.tCheckerboard
         CompuCellSetup.steer(self.contactParseData)
      if not self.counter and self.checkerboardFlag:
         self.switchToSorting()
         self.sortingFlag=True
         self.checkerboardFlag=False
         self.counter=self.tSorted
         CompuCellSetup.steer(self.contactParseData)


class ChemotaxisSteeringExercise9(SteppablePy):
   def __init__(self,_simulator,_frequency=1):
      SteppablePy.__init__(self,_frequency)
      self.simulator=_simulator
      self.chemotaxisParseData=CompuCellSetup.getModuleParseData("Chemotaxis")

      self.nTrackerPlugin=CompuCell.getNeighborTrackerPlugin()
      self.inventory=self.simulator.getPotts().getCellInventory()
      self.cellList=CellList(self.inventory)
   def start(self):
      for cell in self.cellList:
         cell.targetVolume=25
         cell.lambdaVolume=15.0
         cell.targetSurface=20
         cell.lambdaSurface=4.0


   def step(self, _mcs):
      for cell in self.cellList:
         if cell.type==1:
            cellNeighborList=CellNeighborListAuto(self.nTrackerPlugin,cell)
            for neighborSurfaceData in cellNeighborList:
               if neighborSurfaceData.neighborAddress:
                  if neighborSurfaceData.neighborAddress.type==2:
               # touches macrophage
                     cell.targetVolume=0
                     cell.lambdaVolume=10000.0



      if _mcs>100 and not _mcs%100:
         cfd=self.chemotaxisParseData.getChemotaxisFieldData("FastDiffusionSolver2DFE","ATTR")
         cd=cfd.getChemotaxisData(0) # get 0 th element of the ChemotaxisData vector
         lm=cd.getLambda()
         cd.Lambda(lm-0.2)
         CompuCellSetup.steer(self.chemotaxisParseData)

class ConcentrationFieldDumperSteppable(SteppablePy):
   def __init__(self,_simulator,_frequency=1):
      SteppablePy.__init__(self,_frequency)
      self.simulator=_simulator
      self.dim=self.simulator.getPotts().getCellFieldG().getDim()

   def setFieldName(self,_fieldName):
      self.fieldName=_fieldName

   def step(self,mcs):
      fileName=self.fieldName+"_"+str(mcs)+".dat"
      self.outputField(self.fieldName,fileName)

   def outputField(self,_fieldName,_fileName):
      field=CompuCell.getConcentrationField(self.simulator,_fieldName)
      pt=CompuCell.Point3D()
      if field:
         try:
            fileHandle=open(_fileName,"w")
         except IOError:
            print "Could not open file ", _fileName," for writing. Check if you have necessary permissions"

         print "dim.x=",self.dim.x
         for i in xrange(self.dim.x):
            for j in xrange(self.dim.y):
               for k in xrange(self.dim.z):
                  pt.x=i
                  pt.y=j
                  pt.z=k
                  fileHandle.write("%d\t%d\t%d\t%f\n"%(pt.x,pt.y,pt.z,field.get(pt)))

from PlayerPython import *
from math import *

class ExtraFieldVisualizationSteppable(SteppablePy):
   def __init__(self,_simulator,_frequency=10):
      SteppablePy.__init__(self,_frequency)
      self.simulator=_simulator
      self.cellFieldG=self.simulator.getPotts().getCellFieldG()
      self.dim=self.cellFieldG.getDim()
      
   def setScalarField(self,_field):
      self.scalarField=_field
   
   def start(self):pass

   def step(self,mcs):
      for x in xrange(self.dim.x):
         for y in xrange(self.dim.y):
            for z in xrange(self.dim.z):
               pt=CompuCell.Point3D(x,y,z)
               if (not mcs%20):
                  value=x*y
                  fillScalarValue(self.scalarField,x,y,z,value)
               else:
                  value=sin(x*y)
                  fillScalarValue(self.scalarField,x,y,z,value)

class PressureFieldVisualizationSteppable(SteppablePy):
   def __init__(self,_simulator,_frequency=10):
      SteppablePy.__init__(self,_frequency)
      self.simulator=_simulator
      self.cellFieldG=self.simulator.getPotts().getCellFieldG()
      self.dim=self.cellFieldG.getDim()
      
   def setScalarField(self,_field):
      self.scalarField=_field
   
   def start(self):pass

   def step(self,mcs):
      for x in xrange(self.dim.x):
         for y in xrange(self.dim.y):
            for z in xrange(self.dim.z):
               pt=CompuCell.Point3D(x,y,z)
               cell=self.cellFieldG.get(pt)
               if cell:
                  fillScalarValue(self.scalarField,x,y,z, cell.targetVolume-cell.volume)
               else:
                  fillScalarValue(self.scalarField,x,y,z,0)


class VolumeParamSteppable(SteppablePy):
   def __init__(self,_simulator,_frequency=1):
      SteppablePy.__init__(self,_frequency)
      self.simulator=_simulator
      self.inventory=self.simulator.getPotts().getCellInventory()
      self.cellList=CellList(self.inventory)
   def start(self):
      for cell in self.cellList:
         cell.targetVolume=25
         cell.lambdaVolume=2.0
   def step(self,mcs):
      for cell in self.cellList:
         cell.targetVolume+=1

